<template>
  <v-dialog v-model="showModalTutors" scrollable max-width="700px" persistent>
    <v-card>
      <v-card-text class="pop">
        <v-row>
          <v-col md="12">
            <div class="title text-center">Agregar tutores a la tutoría</div>
          </v-col>
        </v-row>

        <v-row>
          <v-col>
            <st-search md="12" text="Buscar por nombre o código de tutor" @enter="searchTutor($event)"/>
            <st-select-table
              :dataInfo="{ headers, items, key }"
              :loading="tableLoading"
              @selected="captureTutor($event)"/>
            <div class="items-box">
              <div v-for="(tutor, index) in tutors" :key="tutors.codigo">
                <v-btn small text @click="deleteTutor(index)">X</v-btn>
                {{ tutor.nombre }}
              </div>
            </div>
            <div class="content-footer">
              <st-secondary-btn nombre="Cancelar" @click="closeModal()"/>
              <st-primary-btn nombre="Agregar tutores" :loading="registering" @click="registerTutorsInTutorship()"/>
            </div>
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
import DataTablePopup from "./DataTablePopup";
import Search from "./Search";
import SelectTable from "./SelectTable";
import {mapState} from "vuex";

export default {
  name: "TutorshipTutorsModal",
  data() { return {
    key: 'idTutor',
    tutors: [],
    tableLoading: false,
    registering: false,
  }},
  props:['value'],
  components: {
    'st-data-table': DataTablePopup,
    'st-search': Search,
    'st-select-table': SelectTable,
  },
  computed: {
    ...mapState('tutorships', {
      showModalTutors: (state) => state.showModalTutors,
      headers: (state) => state.tutorsTableHeaders,
      items: (state) => state.modalTutors,
    }),
  },
  methods: {
    searchTutor(value) {
      const idTutorship = this.$route.params.id;
      this.tableLoading = true;
      this.$store.dispatch('tutorships/searchTutorsToAddInTutorship', {
        idTutorship: idTutorship,
        searchQuery: value
      }).then(() => this.tableLoading = false);
    },
    captureTutor(value) {
      let tutors = this.tutors.filter((obj) => obj.idTutor === value.idTutor)
      // si no se encuentra en la lista de tutores, se le agrega a dicha lista
      if (tutors.length === 0) this.tutors.push({idTutor: value.idTutor, nombre: value.nombre})
    },
    deleteTutor(index){
      this.tutors.splice(index, 1);
    },
    registerTutorsInTutorship() {
      this.registering = true;
      const idTutorship = this.$route.params.id;
      const idUnit = this.$store.state.role.idUnit;
      this.$store.dispatch('tutorships/registerTutorsInTutorship', {
        idTutorship: idTutorship,
        idUnit: idUnit,
        tutors: this.tutors
      }).then((res) => {
        this.$store.dispatch('tutorships/updateTutorsInTutorship', {idTutorship: idTutorship, searchQuery: ""});
        this.registering = false;
        this.closeModal();
      });
    },
    closeModal() {
      this.tutors.splice(0, this.tutors.length);
      this.searchTutor("");
      this.$store.dispatch('tutorships/closeTutorsModal');
    },
  },
  mounted() {
    this.searchTutor("");
  },
}
</script>

<style scoped>

</style>
